<?php
// $Id: pg_simplepay.admin.inc,v 1.3 2009/11/24 22:06:36 gor Exp $

/********************************************************************
 * Functions callback
 ********************************************************************/

function pg_simplepay_common(){


  $form['pg_simplepay_show'] = array (
    '#type'          => 'select',
    '#title'         => t('Price fieldset'),
    '#default_value' => variable_get('pg_simplepay_show',TRUE),
    '#options'       => array(
            TRUE  => t('Show'),
            FALSE => t('Hide'),
    ),
    '#description'   => t('Show price fieldset'),
  );
  $form['pg_simplepay_link_show'] = array (
    '#type'          => 'select',
    '#title'         => t('Purchase link'),
    '#default_value' => variable_get('pg_simplepay_link_show',TRUE),
    '#options'       => array(
            TRUE  => t('Show'),
            FALSE => t('Hide'),
    ),
    '#description'   => t('Show purchase link'),
  );
  $form['pg_simplepay_position'] = array (
    '#type'          => 'select',
    '#title'         => t('Symbol position'),
    '#default_value' => variable_get('pg_simplepay_position',TRUE),
    '#options'       => array(
            TRUE  => t('Left'),
            FALSE => t('Right'),
    ),
    '#description'   => t('This option places the currency symbol of the left or right side of the price.'),
  );
  $form['pg_simplepay_symbol'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Symbol'),
    '#default_value' => variable_get('pg_simplepay_symbol','$'),
    '#description'   => t("Please enter symbol of the simplepay currency."),
  );
  $form['pg_simplepay_thousands'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Thousands separator'),
    '#default_value' => variable_get('pg_simplepay_thousands', ','),
    '#size'          => 3,
    '#maxlength'     => 5,
    '#description'   => t('Enter the sign for the thousands separator.')
   );
   $form['pg_simplepay_decimal'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Decimal separator'),
    '#default_value' => variable_get('pg_simplepay_decimal', '.'),
    '#size'          => 3,
    '#maxlength'     => 5,
    '#description'   => t('Enter the sign to seperate real numbers from floating numbers.')
   );
  $form['pg_simplepay_decimal_places'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Number of places after the decimal separator'),
    '#default_value' => variable_get('pg_simplepay_decimal_places', 2),
    '#size'          => 3,
    '#maxlength'     => 5,
    '#description'   => t('How many slots are needed after the decimal?')
   );

   $form['pg_simplepay_msg_buy_node'] = array(
     '#type'          => 'textarea',
     '#title'         => t('Custom buy node message'),
     '#rows'		   => 3,
     '#default_value' => variable_get('pg_simplepay_msg_buy_node', ''),
   );

   $form['pg_simplepay_msg_buy_role'] = array(
     '#type'          => 'textarea',
     '#title'         => t('Custom buy role message'),
     '#rows'		   => 3,
     '#default_value' => variable_get('pg_simplepay_msg_buy_role', ''),
   );

   $form['pg_simplepay_msg_buy_node_or_role'] = array(
     '#type'          => 'textarea',
     '#title'         => t('Custom buy node OR role message'),
     '#rows'		   => 3,
     '#default_value' => variable_get('pg_simplepay_msg_buy_node_or_role', ''),
   );

   $form['pg_simplepay_msg_purchased_node'] = array(
     '#type'          => 'textarea',
     '#title'         => t('Custom node purchased message'),
     '#rows'		   => 3,
     '#default_value' => variable_get('pg_simplepay_msg_purchased_node', ''),
   );
   $form['pg_simplepay_msg_purchased_role'] = array(
     '#type'          => 'textarea',
     '#title'         => t('Custom role purchased message'),
     '#rows'		   => 3,
     '#default_value' => variable_get('pg_simplepay_msg_purchased_role', ''),
   );
   $form['pg_simplepay_msg_free_node'] = array(
     '#type'          => 'textarea',
     '#title'         => t('Custom free node message'),
     '#rows'		   => 3,
     '#default_value' => variable_get('pg_simplepay_msg_free_node', ''),
   );

  return system_settings_form($form);
}

function pg_simplepay_prepay ($node){
  global $user;
  $t = (object)(NULL);
  $t->amount=$node->pg_simplepay_price;
  $t->type='pg_simplepay';
  $t->uid=$user->uid;
  $t->title=t('You have been ordered !title ', array('!title' => l($node->title, 'node/'.$node->nid.'/buy', array('html'=>true))));
  $t->extra=array(
    'nid' => $node->nid,
    'vid' => $node->vid,
  );
  $t = pgapi_transaction_save($t);
  $payment_url=  url('payment/'. $t->txnid, array('absolute' => TRUE));
  drupal_goto($payment_url);
  return '';
}

function pg_simplepay_complete (&$form_state,$t){
  $form['amount'] = array(
    '#type'  => 'markup',
    '#value' => t('!currency !amount', array('!amount' => $t->amount,'!currency' => variable_get('pg_simplepay_symbol','$')))
  );
  $form['title'] = array(
    '#type'  => 'markup',
    '#value' => $t->title
  );
  $form['method'] = array(
    '#type'  => 'markup',
    '#value' => module_invoke($t->method, 'pgapi_gw','display name')
  );
  $form['link'] = array(
    '#type'  => 'markup',
    '#value' => l(t('Go to purchased document'), 'node/'.$t->extra['nid'].'/buy')
  );
  return $form;
}

/********************************************************************
 * Other Functions
 ********************************************************************/


function pg_simplepay_purchase(){
  global $user;


  $header = array(
    array('data' => t('Role name'), 'field' => 'rid', 'sort' => 'desc'),
    array('data' => t('Time from'), 'field' => 'enable_date' ),
    array('data' => t('Time expire'), 'field' => 'disable_date' ),
  );

  $result = pager_query("SELECT rs.* FROM {role_schedule} rs WHERE rs.uid = %d AND module = '%s'".tablesort_sql($header), 4, 0, null, $user->uid, 'pg_rolepay');
  while ($item = db_fetch_object($result)) {
  	 $row = array();
	 $row[] = pg_rolepay_get_role_name($item->rid);
	 $row[] = format_date($item->enable_date, 'small');
	 $row[] = format_date($item->disable_date, 'small');
  	 $rows[] = $row;
  }
  $output.='<div width=99% style="overflow-x: auto; ">';
  $output.='<b>'.t('Purchased roles').'</b>:<br>';
  if ($rows) {
	  $pager = theme('pager', NULL, 4, 0);
	  if (!empty($pager)) $rows[] = array(array('data' => $pager, 'colspan' => 10));
	  $output.= theme("table", $header, $rows, array('class'=>'data'));
  } else {
	  $output.='у вас нет оплаченных подписок';
  }
  $output.="</div>";

  $rows = array();
  $header = array(
    array('data' => t('ID'), 'field' => 'nid', 'sort' => 'desc'),
    array('data' => t('Type'), 'field' => 'node.type'),
    array('data' => t('Title'), 'field' => 'node.title'),
  );
  $result = pager_query("SELECT p.* FROM {pg_simplepay_payment} p LEFT JOIN node ON node.nid=p.nid  WHERE p.uid = %d ".tablesort_sql($header), 4, 0, null, $user->uid);
  while ($item = db_fetch_object($result)) {
  	 $row = array();
  	 $node = node_load($item->nid);
  	 if ($node) {
		 $row[] = l($item->nid,'node/'.$node->nid);
		 $row[] = node_get_types('name',$node->type);
		 $row[] = l($node->title,'node/'.$node->nid);
  	 }
  	 $rows[] = $row;
  }
  $output.='<br><div width=99% style="overflow-x: auto; ">';
  $output.='<b>'.t('Purchased nodes').'</b>:<br>';
  if ($rows) {
	  $pager = theme('pager', NULL, 4, 0);
	  if (!empty($pager)) $rows[] = array(array('data' => $pager, 'colspan' => 10));
	  $output.= theme("table", $header, $rows, array('class'=>'data'));
  } else {
	  $output.='у вас нет оплаченных документов';
  }
  $output.="</div>";

  return $output;
}
